Public Member Functions | Static Public Attributes | Private Types | Private Member Functions | Private Attributes

# OrdersWindow Struct Reference

Order window code for all vehicles. More...

Inheritance diagram for OrdersWindow:

## Public Member Functions
| OrdersWindow (const WindowDesc *desc, const Vehicle *v)
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | OnInvalidateData (int data=0, bool gui_scope=true)
| Some data on this window has become invalid.
void | UpdateButtonState ()
virtual void | OnPaint ()
| The window must be repainted.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | OnQueryTextFinished (char *str)
| The query window opened from this window has closed.
virtual void | OnDropdownSelect (int widget, int index)
| A dropdown option associated to this window has been selected.
virtual void | OnDragDrop (Point pt, int widget)
| A dragged 'object' has been released.
virtual EventState | OnKeyPress (uint16 key, uint16 keycode)
| A key has been pressed.
virtual void | OnPlaceObject (Point pt, TileIndex tile)
| The user clicked some place on the map when a tile highlight mode has been set.
virtual bool | OnVehicleSelect (const Vehicle *v)
virtual void | OnPlaceObjectAbort ()
| The user cancelled a tile highlight mode that has been set.
virtual void | OnMouseDrag (Point pt, int widget)
| An 'object' is being dragged at the provided position, highlight the target if possible.
virtual void | OnResize ()
| Called after the window got resized.
## Static Public Attributes
static Hotkey< OrdersWindow > | order_hotkeys []
## Private Types
enum | OrderPlaceObjectState { OPOS_GOTO, OPOS_CONDITIONAL, OPOS_SHARE }
| Under what reason are we using the PlaceObject functionality?
enum | DisplayPane { DP_GROUNDVEHICLE_ROW_NORMAL = 0, DP_GROUNDVEHICLE_ROW_CONDITIONAL = 1, DP_LEFT_LOAD = 0, DP_LEFT_REFIT = 1, DP_MIDDLE_UNLOAD = 0, DP_MIDDLE_SERVICE = 1, DP_RIGHT_EMPTY = 0, DP_RIGHT_REFIT = 1, DP_ROW_LOAD = 0, DP_ROW_DEPOT = 1, DP_ROW_CONDITIONAL = 2, DP_BOTTOM_MIDDLE_DELETE = 0, DP_BOTTOM_MIDDLE_STOP_SHARING = 1 }
| Displayed planes of the NWID_SELECTION widgets. More...
## Private Member Functions
VehicleOrderID | OrderGetSel () const
| Return the memorised selected order.
VehicleOrderID | GetOrderFromPt (int y)
| Calculate the selected order.
void | OrderClick_Goto (int i)
| Handle the click on the goto button.
void | OrderClick_FullLoad (int load_type)
| Handle the click on the full load button.
void | OrderHotkey_NoLoad (int i)
| Handle the 'no loading' hotkey.
void | OrderClick_Service (int i)
| Handle the click on the service.
void | OrderClick_NearestDepot (int i)
| Handle the click on the service in nearest depot button.
void | OrderClick_Conditional (int i)
| Handle the click on the conditional order button.
void | OrderClick_Share (int i)
| Handle the click on the share button.
void | OrderClick_Unload (int unload_type)
| Handle the click on the unload button.
void | OrderHotkey_Transfer (int i)
| Handle the transfer hotkey.
void | OrderHotkey_NoUnload (int i)
| Handle the 'no unload' hotkey.
void | OrderClick_Nonstop (int non_stop)
| Handle the click on the nonstop button.
void | OrderClick_Skip (int i)
| Handle the click on the skip button.
void | OrderClick_Delete (int i)
| Handle the click on the delete button.
void | OrderClick_StopSharing (int i)
| Handle the click on the 'stop sharing' button.
void | OrderClick_Refit (int i, bool auto_refit)
| Handle the click on the refit button.
void | UpdateAutoRefitState ()
| Cache auto-refittability of the vehicle chain.
## Private Attributes
int | selected_order
VehicleOrderID | order_over
| Order over which another order is dragged, `INVALID_VEH_ORDER_ID` if none.
OrderPlaceObjectState | goto_type
const Vehicle * | vehicle
| Vehicle owning the orders being displayed and manipulated.
Scrollbar * | vscroll
bool | can_do_autorefit
| Vehicle chain can be auto-refitted.

## Detailed Description

Order window code for all vehicles.

At the bottom of the window two button rows are located for changing the orders of the vehicle.

## Top row

The top-row is for manipulating an individual order. What row is displayed depends on the type of vehicle, and whether or not you are the owner of the vehicle.

The top-row buttons of one of your trains or road vehicles is one of the following three cases:

     * +-----------------+-----------------+-----------------+-----------------+
     * |    NON-STOP     |    FULL_LOAD    |     UNLOAD      |      REFIT      | (normal)
     * +-----------------+-----+-----------+-----------+-----+-----------------+
     * |       COND_VAR        |    COND_COMPARATOR    |      COND_VALUE       | (for conditional orders)
     * +-----------------+-----+-----------+-----------+-----+-----------------+
     * |    NON-STOP     |      REFIT      |     SERVICE     |     (empty)     | (for depot orders)
     * +-----------------+-----------------+-----------------+-----------------+
     *

Airplanes and ships have one of the following three top-row button rows:

     * +-----------------+-----------------+-----------------+
     * |    FULL_LOAD    |     UNLOAD      |      REFIT      | (normal)
     * +-----------------+-----------------+-----------------+
     * |    COND_VAR     | COND_COMPARATOR |   COND_VALUE    | (for conditional orders)
     * +-----------------+--------+--------+-----------------+
     * |            REFIT         |          SERVICE         | (for depot order)
     * +--------------------------+--------------------------+
     *

## Bottom row

The second row (the bottom row) is for manipulating the list of orders:

     * +-----------------+-----------------+-----------------+
     * |      SKIP       |     DELETE      |      GOTO       |
     * +-----------------+-----------------+-----------------+
     *

For vehicles of other companies, both button rows are not displayed.

Definition at line 479 of file order_gui.cpp.

## Member Enumeration Documentation

enum OrdersWindow::DisplayPane`[private]`

Displayed planes of the NWID_SELECTION widgets.

Enumerator:

  DP_GROUNDVEHICLE_ROW_NORMAL | Display the row for normal/depot orders in the top row of the train/rv order window.
  DP_GROUNDVEHICLE_ROW_CONDITIONAL | Display the row for conditional orders in the top row of the train/rv order window.
  DP_LEFT_LOAD | Display 'load' in the left button of the top row of the train/rv order window.
  DP_LEFT_REFIT | Display 'refit' in the left button of the top row of the train/rv order window.
  DP_MIDDLE_UNLOAD | Display 'unload' in the middle button of the top row of the train/rv order window.
  DP_MIDDLE_SERVICE | Display 'service' in the middle button of the top row of the train/rv order window.
  DP_RIGHT_EMPTY | Display an empty panel in the right button of the top row of the train/rv order window.
  DP_RIGHT_REFIT | Display 'refit' in the right button of the top row of the train/rv order window.
  DP_ROW_LOAD | Display 'load' / 'unload' / 'refit' buttons in the top row of the ship/airplane order window.
  DP_ROW_DEPOT | Display 'refit' / 'service' buttons in the top row of the ship/airplane order window.
  DP_ROW_CONDITIONAL | Display the conditional order buttons in the top row of the ship/airplane order window.
  DP_BOTTOM_MIDDLE_DELETE | Display 'delete' in the middle button of the bottom row of the vehicle order window.
  DP_BOTTOM_MIDDLE_STOP_SHARING | Display 'stop sharing' in the middle button of the bottom row of the vehicle order window.

Definition at line 489 of file order_gui.cpp.

## Member Function Documentation

virtual void OrdersWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 1099 of file order_gui.cpp.

References _colour_gradient, _current_text_dir, DrawOrderString(), DrawString(), Vehicle::GetNumOrders(), Vehicle::GetOrder(), Scrollbar::GetPosition(), GetSpriteSize(), GetStringBoundingBox(), GfxFillRect(), INVALID_VEH_ORDER_ID, Vehicle::IsOrderListShared(), Scrollbar::IsVisible(), max(), min(), Order::next, order_over, SetDParamMaxValue(), Window::top, vehicle, WD_FRAMERECT_BOTTOM, WD_FRAMERECT_TOP, WD_FRAMETEXT_LEFT, WD_FRAMETEXT_RIGHT, and WID_O_ORDER_LIST.

VehicleOrderID OrdersWindow::GetOrderFromPt | ( | int | y | ) | `[inline, private]`

Calculate the selected order.

The calculation is based on the relative (to the window) y click position and the position of the scrollbar.

Parameters:

  | y | Y-value of the click relative to the window origin

Returns:
  The selected order if the order is valid, else return `INVALID_VEH_ORDER_ID`.

Definition at line 542 of file order_gui.cpp.

References Scrollbar::GetCapacity(), Scrollbar::GetPosition(), INVALID_VEH_ORDER_ID, NWidgetBase::pos_y, and NWidgetBase::resize_y.

Referenced by OnClick(), OnDragDrop(), and OnMouseDrag().

virtual void OrdersWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 1178 of file order_gui.cpp.

References _ctrl_pressed, _local_company, _order_conditional_variable, CMD_INSERT_ORDER, CMD_MODIFY_ORDER, CMD_MSG, ConvertSpeedToDisplaySpeed(), CS_NUMERAL, Window::DeleteChildWindows(), DoCommandP(), Order::GetConditionComparator(), Order::GetConditionValue(), Order::GetConditionVariable(), Order::GetLocation(), Order::GetNonStopType(), Vehicle::GetNumOrders(), Vehicle::GetOrder(), GetOrderFromPt(), HideDropDownMenu(), HT_DRAG, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem< Tpool >::index, INVALID_TILE, INVALID_VEH_ORDER_ID, Order::IsType(), lengthof, Order::MakeConditional(), MOF_STOP_LOCATION, Order::next, OrderClick_Delete(), OrderClick_FullLoad(), OrderClick_Goto(), OrderClick_Nonstop(), OrderClick_Refit(), OrderClick_Service(), OrderClick_Skip(), OrderClick_StopSharing(), OrderClick_Unload(), OrderGetSel(), Vehicle::owner, Order::Pack(), ScrollMainWindowToTile(), SetDParam(), ShowDropDownList(), ShowDropDownMenu(), ShowQueryString(), ShowTimetableWindow(), SPR_CURSOR_MOUSE, Vehicle::tile, BaseVehicle::type, VEH_AIRCRAFT, VEH_TRAIN, vehicle, WID_O_COND_COMPARATOR, WID_O_COND_VALUE, WID_O_COND_VARIABLE, WID_O_DELETE, WID_O_FULL_LOAD, WID_O_GOTO, WID_O_NON_STOP, WID_O_ORDER_LIST, WID_O_REFIT, WID_O_REFIT_DROPDOWN, WID_O_SERVICE, WID_O_SHARED_ORDER_LIST, WID_O_SKIP, WID_O_STOP_SHARING, WID_O_TIMETABLE_VIEW, and WID_O_UNLOAD.

virtual void OrdersWindow::OnDragDrop | ( | Point | pt,
|  | int | widget |
| ) |  |  | `[inline, virtual]`

A dragged 'object' has been released.

Parameters:

  | pt | the point inside the window where the release took place.
  | widget | the widget where the release took place.

Reimplemented from Window.

Definition at line 1398 of file order_gui.cpp.

References CMD_MOVE_ORDER, CMD_MSG, DoCommandP(), Vehicle::GetNumOrders(), GetOrderFromPt(), INVALID_VEH_ORDER_ID, order_over, OrderClick_Delete(), OrderClick_StopSharing(), OrderGetSel(), Window::SetWidgetDirty(), Vehicle::tile, vehicle, WID_O_DELETE, WID_O_ORDER_LIST, and WID_O_STOP_SHARING.

virtual void OrdersWindow::OnDropdownSelect | ( | int | widget,
|  | int | index |
| ) |  |  | `[inline, virtual]`

A dropdown option associated to this window has been selected.

Parameters:

  | widget | the widget (button) that the dropdown is associated with.
  | index | the element in the dropdown that is selected.

Reimplemented from Window.

Definition at line 1355 of file order_gui.cpp.

References CMD_MODIFY_ORDER, CMD_MSG, DoCommandP(), MOF_COND_COMPARATOR, MOF_COND_VARIABLE, OrderClick_Conditional(), OrderClick_FullLoad(), OrderClick_Goto(), OrderClick_NearestDepot(), OrderClick_Nonstop(), OrderClick_Refit(), OrderClick_Service(), OrderClick_Share(), OrderClick_Unload(), Vehicle::tile, vehicle, WID_O_COND_COMPARATOR, WID_O_COND_VARIABLE, WID_O_FULL_LOAD, WID_O_GOTO, WID_O_NON_STOP, WID_O_REFIT_DROPDOWN, WID_O_SERVICE, and WID_O_UNLOAD.

virtual void OrdersWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true` |
| ) |  |  | `[inline, virtual]`

Some data on this window has become invalid.

Parameters:

  | data | Information about the changed data.
  | gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 863 of file order_gui.cpp.

References Window::DeleteChildWindows(), GB(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_vehicle_pool >::Get(), Vehicle::GetNumOrders(), HideDropDownMenu(), INVALID_VEH_ORDER_ID, Scrollbar::IsVisible(), Scrollbar::ScrollTowards(), Scrollbar::SetCount(), UpdateAutoRefitState(), vehicle, VIWD_AUTOREPLACE, VIWD_CONSIST_CHANGED, VIWD_MODIFY_ORDERS, VIWD_REMOVE_ALL_ORDERS, and Window::window_number.

virtual EventState OrdersWindow::OnKeyPress | ( | uint16 | key,
|  | uint16 | keycode |
| ) |  |  | `[inline, virtual]`

A key has been pressed.

Parameters:

  | key | the Unicode value of the key.
  | keycode | the untranslated key code including shift state.

Returns:
  ES_HANDLED if the key press has been handled and no other window should receive the event.

Reimplemented from Window.

Definition at line 1431 of file order_gui.cpp.

References _local_company, ES_HANDLED, ES_NOT_HANDLED, Vehicle::owner, and vehicle.

virtual void OrdersWindow::OnMouseDrag | ( | Point | pt,
|  | int | widget |
| ) |  |  | `[inline, virtual]`

An 'object' is being dragged at the provided position, highlight the target if possible.

Parameters:

  | pt | The point inside the window that the mouse hovers over.
  | widget | The widget the mouse hovers over.

Reimplemented from Window.

Definition at line 1481 of file order_gui.cpp.

References Vehicle::GetNumOrders(), GetOrderFromPt(), INVALID_VEH_ORDER_ID, order_over, OrderGetSel(), Window::SetWidgetDirty(), vehicle, and WID_O_ORDER_LIST.

virtual void OrdersWindow::OnPaint | ( |  | ) | `[inline, virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 1093 of file order_gui.cpp.

References _local_company, Window::DrawWidgets(), Vehicle::owner, and vehicle.

virtual void OrdersWindow::OnPlaceObject | ( | Point | pt,
|  | TileIndex | tile |
| ) |  |  | `[inline, virtual]`

The user clicked some place on the map when a tile highlight mode has been set.

Parameters:

  | pt | the exact point on the map that has been clicked.
  | tile | the tile on the map that has been clicked.

Reimplemented from Window.

Definition at line 1438 of file order_gui.cpp.

References _settings_client, CMD_INSERT_ORDER, CMD_MSG, DoCommandP(), ClientSettings::gui, Order::IsType(), Order::Pack(), GUISettings::quick_goto, Vehicle::tile, and vehicle.

virtual void OrdersWindow::OnQueryTextFinished | ( | char * | str | ) | `[inline, virtual]`

The query window opened from this window has closed.

Parameters:

  | str | the new value of the string, NULL if the window was cancelled or an empty string when the default button was pressed, i.e. StrEmpty(str).

Reimplemented from Window.

Definition at line 1332 of file order_gui.cpp.

References Clamp(), CMD_MODIFY_ORDER, CMD_MSG, ConvertDisplaySpeedToSpeed(), DoCommandP(), Order::GetConditionVariable(), Vehicle::GetOrder(), MOF_COND_VALUE, OCV_LOAD_PERCENTAGE, OCV_MAX_SPEED, OCV_RELIABILITY, OrderGetSel(), StrEmpty(), Vehicle::tile, and vehicle.

virtual void OrdersWindow::OnResize | ( |  | ) | `[inline, virtual]`

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 1501 of file order_gui.cpp.

References Scrollbar::SetCapacityFromWidget(), and WID_O_ORDER_LIST.

void OrdersWindow::OrderClick_Conditional | ( | int | i | ) | `[inline, private]`

Handle the click on the conditional order button.

Parameters:

  | i | Dummy parameter.

Definition at line 630 of file order_gui.cpp.

References ANIMCURSOR_PICKSTATION, HT_NONE, Window::LowerWidget(), Window::SetWidgetDirty(), and WID_O_GOTO.

Referenced by OnDropdownSelect().

void OrdersWindow::OrderClick_Delete | ( | int | i | ) | `[inline, private]`

Handle the click on the delete button.

Parameters:

  | i | Dummy parameter.

Definition at line 730 of file order_gui.cpp.

References _networking, CMD_DELETE_ORDER, CMD_MSG, DoCommandP(), Vehicle::GetNumOrders(), Vehicle::tile, and vehicle.

Referenced by OnClick(), OnDragDrop(), and OrderClick_StopSharing().

void OrdersWindow::OrderClick_FullLoad | ( | int | load_type | ) | `[inline, private]`

Handle the click on the full load button.

Parameters:

  | load_type | the way to load.

Definition at line 574 of file order_gui.cpp.

References CMD_MODIFY_ORDER, CMD_MSG, DoCommandP(), Order::GetLoadType(), Vehicle::GetOrder(), MOF_LOAD, OLF_FULL_LOAD_ANY, OLF_LOAD_IF_POSSIBLE, OrderGetSel(), Vehicle::tile, and vehicle.

Referenced by OnClick(), OnDropdownSelect(), and OrderHotkey_NoLoad().

void OrdersWindow::OrderClick_Goto | ( | int | i | ) | `[inline, private]`

Handle the click on the goto button.

Parameters:

  | i | Dummy parameter.

Definition at line 558 of file order_gui.cpp.

References ANIMCURSOR_PICKSTATION, HT_RECT, HT_VEHICLE, Window::IsWidgetLowered(), Window::SetWidgetDirty(), Window::ToggleWidgetLoweredState(), and WID_O_GOTO.

Referenced by OnClick(), and OnDropdownSelect().

void OrdersWindow::OrderClick_NearestDepot | ( | int | i | ) | `[inline, private]`

Handle the click on the service in nearest depot button.

Parameters:

  | i | Dummy parameter.

Definition at line 614 of file order_gui.cpp.

References _settings_client, CMD_INSERT_ORDER, CMD_MSG, DoCommandP(), ClientSettings::gui, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem< Tpool >::index, Order::MakeGoToDepot(), GUISettings::new_nonstop, Order::next, ODATFB_NEAREST_DEPOT, ODTFB_PART_OF_ORDERS, ONSF_NO_STOP_AT_INTERMEDIATE_STATIONS, Order::Pack(), Order::SetDepotActionType(), Vehicle::tile, and vehicle.

Referenced by OnDropdownSelect().

void OrdersWindow::OrderClick_Nonstop | ( | int | non_stop | ) | `[inline, private]`

Handle the click on the nonstop button.

Parameters:

  | non_stop | what non-stop type to use; -1 to use the 'next' one.

Definition at line 693 of file order_gui.cpp.

References CMD_MODIFY_ORDER, CMD_MSG, DoCommandP(), Order::GetNonStopType(), Vehicle::GetOrder(), Vehicle::IsGroundVehicle(), MOF_NON_STOP, OrderGetSel(), Window::SetWidgetDirty(), Vehicle::tile, vehicle, and WID_O_NON_STOP.

Referenced by OnClick(), and OnDropdownSelect().

void OrdersWindow::OrderClick_Refit | ( | int | i,
|  | bool | auto_refit |
| ) |  |  | `[inline, private]`

Handle the click on the refit button.

If ctrl is pressed, cancel refitting, else show the refit window.

Parameters:

  | i | Selected refit command.
  | auto_refit | Select refit for auto-refitting.

Definition at line 772 of file order_gui.cpp.

References _ctrl_pressed, CMD_ORDER_REFIT, CT_AUTO_REFIT, CT_NO_REFIT, DoCommandP(), OrderGetSel(), ShowVehicleRefitWindow(), Vehicle::tile, and vehicle.

Referenced by OnClick(), and OnDropdownSelect().

void OrdersWindow::OrderClick_Share | ( | int | i | ) | `[inline, private]`

Handle the click on the share button.

Parameters:

  | i | Dummy parameter.

Definition at line 642 of file order_gui.cpp.

References ANIMCURSOR_PICKSTATION, HT_VEHICLE, Window::LowerWidget(), Window::SetWidgetDirty(), and WID_O_GOTO.

Referenced by OnDropdownSelect().

void OrdersWindow::OrderClick_Skip | ( | int | i | ) | `[inline, private]`

Handle the click on the skip button.

If ctrl is pressed, skip to selected order, else skip to current order + 1

Parameters:

  | i | Dummy parameter.

Definition at line 716 of file order_gui.cpp.

References _ctrl_pressed, CMD_MSG, CMD_SKIP_TO_ORDER, BaseConsist::cur_implicit_order_index, DoCommandP(), Vehicle::GetNumOrders(), Vehicle::tile, and vehicle.

Referenced by OnClick().

void OrdersWindow::OrderClick_StopSharing | ( | int | i | ) | `[inline, private]`

Handle the click on the 'stop sharing' button.

If 'End of Shared Orders' isn't selected, do nothing. If Ctrl is pressed, call OrderClick_Delete and exit. To stop sharing this vehicle order list, we copy the orders of a vehicle that share this order list. That way we exit the group of shared vehicles while keeping the same order list.

Parameters:

  | i | Dummy parameter.

Definition at line 748 of file order_gui.cpp.

References _ctrl_pressed, CMD_CLONE_ORDER, CMD_MSG, DoCommandP(), Vehicle::FirstShared(), Vehicle::GetNumOrders(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem< Tpool >::index, Vehicle::IsOrderListShared(), Vehicle::NextShared(), OrderClick_Delete(), Vehicle::PreviousShared(), Vehicle::tile, and vehicle.

Referenced by OnClick(), and OnDragDrop().

VehicleOrderID OrdersWindow::OrderGetSel | ( |  | ) | const`[inline, private]`

Return the memorised selected order.

Returns:
  the memorised order if it is a valid one else return the number of orders

Definition at line 528 of file order_gui.cpp.

References Vehicle::GetNumOrders(), and vehicle.

Referenced by OnClick(), OnDragDrop(), OnMouseDrag(), OnQueryTextFinished(), OrderClick_FullLoad(), OrderClick_Nonstop(), OrderClick_Refit(), OrderClick_Service(), OrderClick_Unload(), and SetStringParameters().

virtual void OrdersWindow::SetStringParameters | ( | int | widget | ) | const`[inline, virtual]`

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters:

  | widget | Widget number.

Reimplemented from Window.

Definition at line 1157 of file order_gui.cpp.

References ConvertSpeedToDisplaySpeed(), Order::GetConditionValue(), Order::GetConditionVariable(), Vehicle::GetOrder(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem< Tpool >::index, Order::IsType(), OrderGetSel(), SetDParam(), vehicle, WID_O_CAPTION, and WID_O_COND_VALUE.

void OrdersWindow::UpdateAutoRefitState | ( |  | ) | `[inline, private]`

Cache auto-refittability of the vehicle chain.

Definition at line 787 of file order_gui.cpp.

References can_do_autorefit, EF_AUTO_REFIT, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_engine_pool >::Get(), HasBit(), Vehicle::Next(), and vehicle.

Referenced by OnInvalidateData().

virtual void OrdersWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 826 of file order_gui.cpp.

References _order_conditional_variable, GetStringBoundingBox(), INVALID_STRING_ID, lengthof, maxdim(), WD_FRAMERECT_TOP, WID_O_COND_COMPARATOR, WID_O_COND_VARIABLE, and WID_O_ORDER_LIST.

## Field Documentation

Hotkey< OrdersWindow > OrdersWindow::order_hotkeys`[static]`

Initial value:

     {
      Hotkey<OrdersWindow>('D', "skip", 0, &OrdersWindow::OrderClick_Skip),
      Hotkey<OrdersWindow>('F', "delete", 0, &OrdersWindow::OrderClick_Delete),
      Hotkey<OrdersWindow>('G', "goto", 0, &OrdersWindow::OrderClick_Goto),
      Hotkey<OrdersWindow>('H', "nonstop", 0, &OrdersWindow::OrderClick_Nonstop),
      Hotkey<OrdersWindow>('J', "fullload", 0, &OrdersWindow::OrderClick_FullLoad),
      Hotkey<OrdersWindow>('K', "unload", 0, &OrdersWindow::OrderClick_Unload),
      Hotkey<OrdersWindow>((uint16)0, "nearest_depot", 0, &OrdersWindow::OrderClick_NearestDepot),
      Hotkey<OrdersWindow>((uint16)0, "always_service", 0, &OrdersWindow::OrderClick_Service),
      Hotkey<OrdersWindow>((uint16)0, "force_unload", 0, &OrdersWindow::OrderClick_Unload),
      Hotkey<OrdersWindow>((uint16)0, "transfer", 0, &OrdersWindow::OrderHotkey_Transfer),
      Hotkey<OrdersWindow>((uint16)0, "no_unload", 0, &OrdersWindow::OrderHotkey_NoUnload),
      Hotkey<OrdersWindow>((uint16)0, "no_load", 0, &OrdersWindow::OrderHotkey_NoLoad),

    }

Definition at line 1507 of file order_gui.cpp.

The documentation for this struct was generated from the following file:

- src/order_gui.cpp